require 'base_function'

class EntropyFunction < BaseFunction

  def log2(v)
    return (Math.log10(v)/Math.log10(2))
  end

  def evaluate_pos(i)
    res = 0

    nseq = @freq_table.nseq(i) || 0

    if nseq>0 
      @freq_table.frequency_table.keys.each do |k|

        if k!='-'
          freq = @freq_table.frequency_table[k][i] || 0 

          co = freq.to_f/nseq.to_f
          if (co > 0)
            res += ((-1*co*log2(co)));
          end
        end
      end

    end

    return res

  end

end
