
require 'frequency_table.rb'
require 'entropy_function'


class Cominer
  
  attr_accessor :regions,:snps,:position_table, :freq_table, :single_points, :entropy_function
  
  def initialize(contig)
    
    @freq_table = FrequencyTable.new
  
  	contig.reads.each do |name,read|
      # puts ">#{read.name} #{read.orientation} #{read.align_clip_start} #{read.align_clip_end} #{read.start_in_consensus}"
      # puts read.fasta[read.align_clip_start.to_i..read.align_clip_end.to_i]
      # puts read.fasta
  		@freq_table.add_read(read)
  	end
  	
    # puts freq_table.inspect
    #     exit
    #     
  	@entropy_function = EntropyFunction.new(@freq_table)
   
    @regions=@entropy_function.regions
    @snps=@entropy_function.snps
    @single_points=@entropy_function.single_points
    
    @freq_table.position_table.delete('-')
    
		@position_table = @freq_table.position_table
		
    
  end  
  
  
end